
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>pg: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">crudapp/internal/link/repository/pg/link_pg_repo.go (100.0%)</option>
				
				<option value="file1">crudapp/internal/user/repository/pg/user_pg_repo.go (100.0%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package pg

import (
        "crudapp/internal/domain"
        "database/sql"
)

type LinkPgRepository struct {
        DB *sql.DB
}

func NewLinkPgRepository(db *sql.DB) *LinkPgRepository <span class="cov8" title="1">{
        return &amp;LinkPgRepository{
                DB: db,
        }
}</span>

func (lr *LinkPgRepository) Create(link *domain.Link) (int, error) <span class="cov8" title="1">{
        var id int
        err := lr.DB.QueryRow(
                "INSERT INTO link (user_id, token, long_link, clicks_count) VALUES ($1, $2, $3, 0) RETURNING id;",
                link.UserID, link.Token, link.LongLink).
                Scan(&amp;id)
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>
        <span class="cov8" title="1">return id, nil</span>
}

func (lr *LinkPgRepository) GetByToken(token string) (*domain.Link, error) <span class="cov8" title="1">{
        link := &amp;domain.Link{}

        err := lr.DB.QueryRow(
                "SELECT id, user_id, token, long_link, clicks_count FROM link WHERE token=$1", token).
                Scan(&amp;link.ID, &amp;link.UserID, &amp;link.Token, &amp;link.LongLink, &amp;link.ClicksCount)

        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return link, nil</span>
}

func (lr *LinkPgRepository) GetByUserID(userID int) ([]*domain.Link, error)<span class="cov8" title="1">{
        var links []*domain.Link
        rows, err := lr.DB.Query(
                "SELECT id, user_id, token, long_link, clicks_count FROM link WHERE user_id=$1", userID)

        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">for rows.Next() </span><span class="cov8" title="1">{
                l := &amp;domain.Link{}
                err := rows.Scan(&amp;l.ID, &amp;l.UserID, &amp;l.Token, &amp;l.LongLink, &amp;l.ClicksCount)
                if err != nil </span><span class="cov8" title="1">{
                        return nil, err
                }</span>

                <span class="cov8" title="1">links = append(links, l)</span>
        }

        <span class="cov8" title="1">return links, nil</span>
}
func (lr *LinkPgRepository) GetByLongLink(longLink string) (*domain.Link, error) <span class="cov8" title="1">{
        link := &amp;domain.Link{}

        err := lr.DB.QueryRow(
                "SELECT id, user_id, token, long_link, clicks_count FROM link WHERE long_link=$1", longLink).
                Scan(&amp;link.ID, &amp;link.UserID, &amp;link.Token, &amp;link.LongLink, &amp;link.ClicksCount)

        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return link, nil</span>
}
func (lr *LinkPgRepository) IncrementClicksCount(token string) error <span class="cov8" title="1">{
        _, err := lr.DB.Exec(
                "UPDATE link SET clicks_count = clicks_count + 1 WHERE token=$1", token)
        if err != nil </span><span class="cov8" title="1">{
                return err
        }</span>

        <span class="cov8" title="1">return nil</span>
}
</pre>
		
		<pre class="file" id="file1" style="display: none">package pg

import (
        "crudapp/internal/domain"
        "database/sql"
        "github.com/sirupsen/logrus"
)

type UserPgRepository struct {
        DB *sql.DB
}

func NewUserPgRepository(db *sql.DB) *UserPgRepository <span class="cov8" title="1">{
        return &amp;UserPgRepository{
                DB: db,
        }
}</span>

func (repo *UserPgRepository) Create(user domain.User) (int, error) <span class="cov8" title="1">{
        var id int
        logrus.Debug(user.Email, user.Password)
        err := repo.DB.QueryRow(`INSERT INTO users (email, password) VALUES ($1, $2) RETURNING id;`,
                        user.Email,
                        user.Password).
                Scan(&amp;id)
        logrus.Debug(err)
        if err != nil </span><span class="cov8" title="1">{
                return 0, err
        }</span>

        <span class="cov8" title="1">return id, nil</span>
}

func (repo *UserPgRepository) GetByID(userID int) (*domain.User, error) <span class="cov8" title="1">{
        user := &amp;domain.User{}
        logrus.Debug("Get by id")

        err := repo.DB.QueryRow("SELECT id, email, password FROM users WHERE id=$1", userID).
                Scan(&amp;user.ID, &amp;user.Email, &amp;user.Password)
        if err == sql.ErrNoRows </span><span class="cov8" title="1">{
                return nil, domain.ErrAuthUserNotFound
        }</span>
        <span class="cov8" title="1">if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return user, nil</span>
}

func (repo *UserPgRepository) GetByEmail(email string) (*domain.User, error) <span class="cov8" title="1">{
        user := &amp;domain.User{}
        logrus.Debug("Get by email")

        err := repo.DB.QueryRow("SELECT id, email, password FROM users WHERE email=$1", email).
                Scan(&amp;user.ID, &amp;user.Email, &amp;user.Password)
        if err != nil </span><span class="cov8" title="1">{
                return nil, err
        }</span>

        <span class="cov8" title="1">return user, nil</span>

}</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
